# nestjs-postgres

To create a project, run "nest new nestjs-postgres".
To start project in development mode, run "npm run start:dev".
To disable eslint, comment whole object content inside eslintrc.js file.

## Generating files

Then delete all app.\* files. This will cause error in main.ts file. To solve this error, we are going to create MessagesModule, with all additional files. To do that, run "nest generate module messages" and replace AppModule with MessagesModule in main.ts. There is no need to delete app.\* files, ever.
Next, to generate appropriate controller run "nest generate controller messages/messages --flat". Flat flag tells nestjs to not create controller folder.

## Decorators

Decorators can be used on classes, methods or arguments. Example of class decorators are @Controller, @Module etc, methods @Get, @Post and argument @Param, @Query, @Heder and @Body. Argument decorators are stated in parenthesis of methods. If we want to extract id from request, we can do that with @Param('id') decorator. Query value can be extracted using @Query() decorator, part of the header using @Headers() decorator, and parts of the body using @Body() decorator.

## Pipes (validation)

Nestjs makes validating parameters easy using pipes. Pipes check if parameters meet certain conditions before being passed to controllers (methods). To use ValidationPipe through whole project, it needs to be imported inside main.ts file and set app.useGlobalPipes(). When use parameter whitelist: true, we are stripping all additional parameters, if any, before passing parameters to the controller.
To validate request, nestjs uses data transfer object (DTO). They are, usually, created in dto sub folders and they use class-validator library that needs to be installed. This library, and another one, can be installed running command: "npm install class-validator class-transformer". Then we can add decorators to check if parameter meets certain conditions. The last step is to import DTO inside appropriate controller and to decorate method. To check if body meets certain criteria, we set body parameter to DTO class (@Body() body: CreateMessageDTO). This work in TypeScript thanks to "emitDecoratorMetadata": true parameter in tsconfig.json that transforms this type to JavaScript. Class-transformer turns json object into instance of DTO class. Class-validator then validates the instance, and responds immediately in case of a validation error, otherwise provides body to request handler.

## Repository and service

Those two types of files can be created/generated using cli, but can easily be created from scratch. Repository contains all the logic regarding storing of data, and services all the business logic and call methods from repository. They often have same methods (method names). Since service invokes methods from repository, repository needs to be imported inside service class and initialized inside service class constructor. That way service creates its own dependencies. THIS SHOULDN'T BE DONE IN PRODUCTION APPS. Instead, dependency injections should be used. Lastly, we connect service with controller, the same way we did it with repository and service.

## Dependency injections and Injectable decorator

Dependency Inversion principle ("D" in SOLID principles) states that "Classes should not create instances of its dependencies on its own.". That is the reason why we should avoid creating instances of dependencies in the constructor. This code is considered bad: "constructor() {this.messagesRepository = new MessagesRepository();}". First thing to do to make it better is to create instance outside of the class and pass it as a parameter to the constructor.
Following code is considered to be better: "constructor(public messagesRepository: MessagesRepository) {}". The best would be to create interface and pass instance that implements that interface. That way, it would be easy to change repository services, eg: for testing and production environment, but that would be very verbose, so in nestjs we are going to use better approach instead of the best.
Nestjs has a "Nest DI Container" (Nest Dependency Injections Container) that keeps list of classes and their dependencies and list of created instances. That way, nestjs can automatically create classes with their dependencies and reuse the same instance of the class wherever that class is needed as a dependency. Classes that ara dependencies for other classes are decorated with @Injectable() decorator, and are stated as providers in module class.Controllers are only consuming other classes, so we don't have to register controllers with DI Container. Generally we register service and repository classes. The last thing to do is to register injectable classes as a providers inside module class. Providers contains a list of classes that can be used as dependencies for other classes. This approach makes testing easier than if classes would create instances of its own dependencies.
If we need to use services from another module, first that service needs to be added in list of exports in @Module() decorator of the first module. That way, service becomes available to the any module that imports first module (adds the first module to the list of imports in @Module() decorator of the second module). After that, in services of the second module, we only need to import service from the first module and pass it as a parameter to the constructor of the first module. Shorter: after importing a module, anything that is listed in exports of that module can be imported. Each @Module() decorator has a lists of: controllers, imports, providers and exports.

## TypeORM

TypeORM is mapper that allows us to work with database. To use it, we need to install two packages "npm i @nestjs/typeorm typeorm". After that, we need to install package for client related to the database we are going to use (PostgreSQL, sqlLite etc.), running command "npm i sqlite3". When using TypeORM we only create entity classes and repository classes are created automatically. To create connection to the database, firstly we need to import TypeOrmModule inside AppModule and add it to the list of the imports in the module, with forRoot() method, that makes TypeOrmModule accessible to the all other modules of the application. This method takes several parameters, like: type - type of DBMS we are going to use ('sqlite', 'postgres' etc); database - name of the database, entities - list of all entities ('\*\*/\*.entity.ts'), all objects/tables that need to be created inside database. and synchronize - true/false, should changes inside entities be synchronized with database automatically.
After creating entity.ts file, it needs to be imported in module, alongside TypeOrmModule, this time with forFeature() method, that will contain list of entities. This steps creates repository for passed entities automatically. The last thing to do is to import entity class inside AppModule and add it to the list of entities inside TypeOrmModule.forRoot() method to connect it to the root connection.
In service class, we need to import Repository from typeorm package and InjectRepository from @nestjs/typeorm, and in constructor pass argument decorated with @InjectRepository(): "constructor(@InjectRepository(User) private repo: Repository\<User\>) {}". repo.create() creates object, but not persisting to the database. That is done with repo.save() method.
To log any action to the database, we can use methods decorated with @AfterInsert(), @AfterUpdate() and @AfterRemove() decorators, inside entity class. Those hooks are called if we use save on a object (create with created method), but won't be called if we save plain object ({ param1: value1, param2: value2 }). Using repository save() and remove() methods, hooks will be invoked, but not while using insert(), update() or delete() methods. AfterRemove decorator returns undefined for this.id, so maybe BeforeRemove decorator should be used.
To update methods, we should pass Partial\<Entity\> objects. This type of object may contain none or some properties, with values, from Entity, and not a single property outside of Entity object.

## Exceptions

Throwing exception (NotFoundException, BadRequestException etc) from service class is considered bad practice, because that service can't be reused if implement web socket, grpc or something similar. They work only for http. That is the reason why exceptions should be handled through exception filters.

## Interceptors - Exclude properties from return object

This can be achieved importing Exclude decorator, inside entity class, and decorating property we want to exclude from return object, such as password from User entity. After that, we only need to decorate, in controller, method that returns object with interceptor "@UseInterceptors(ClassSerializerInterceptor)".
The second way of doing this is to create custom dto and custom interceptor. Interceptors are classes that transform incoming request and outgoing responses before passing them to the end point/method. We will create serialize.interceptor.ts file inside src/interceptors folder, since we are going to use them in all modules where are needed. Interceptor class needs to implement NestInterceptor interface. Inside intercept() method, we write the code that will be run before a request is handled by the request handler, and in return, inside next.handler().pipe() we write the code that will run before the response is sent out: "return plainToClass(this.dto, data, { excludeExtraneousValues: true });". This option ensures that all other properties, that are not exposed, will be removed from object. Last step is to replace ClassSerializerInterceptor, inside UseInterceptors decorator with our custom interceptor. Dto have to have columns decorated with @Expose() decorator. Note: we can create constructor in SerializeInterceptor class and pass appropriate dto class, and making interceptor reusable. Decorators are plain function, so we are going to replace lengthy decorator with name of function which we created in interceptor, to replace decorator for findUser() method. This decorator should intercept responses from all the methods in UserController class, so we are going to decorate controller class with it.

## Hashing

Since we are using scrypt function from standard nest "crypto" module, and it returns callback, we will use promisify function, from standard nest "util" module to transform that callback to promise. Next, we will be hashing combined password and salt, and joining hashed value and salt, with separator. All this is done in sign up method of auth service.

## Cookie session

First, we need to install needed packages: "npm i cookie-session @types/cookie-session". Then, in main.ts wiring up cookie-session middleware. Due to configuration mismatch between nestjs and cookie-session package, we need to use require("cookie-session") instead of import. String in keys of cookieSession middleware will be used to encrypt information that is stored inside of cookie. We will add session object to signin and sign up methods, and store user.id inside session object. Response will contain cookie/session only if we change some value inside session object. If we store same user.id, session won't be part of the response.

## Authentication

We will create current-user.decorator.ts file inside decorators folder and will create decorator that returns current user. context: ExecutionContext is, essentially, a incoming request. This way it allows us to use this decorator regardless regardless of the communication protocol, if it is http, grpc, web socket, graphql etc. For http, we switch it to http and get request object (context.switchToHttp().getRequest()). Data object is any value that is supplied as a parameter to the decorator. In this case, it can be changed from type any to type never, because we are not expecting any parameter. Note: Maybe it can be used to pass list of groups that have access to that method, and authorize users that way. Param decorators exist outside dependency injection system, so our decorators can't get an instance of service directly. Solution is to create interceptor which will get the current user, then use the value produced by it in the decorator. All interceptors we make can be a part of the DI system. We are going to create CurrentUser interceptor that will read session object and injection of a user service. After we find user, inside interceptor, we add it to the request object, because decorators can access a request object (request.currentUser = user;). Since this interceptor uses dependency injections, we are going to wire up it in a different way than we did with the SerializeInterceptor. Whenever we want to run our decorator (CurrentUserDecorator) interceptor has to run first.
First way of wiring up is to add CurrentUserInterceptor to the providers of UsersModule. Then we use this interceptor inside UsersController, on controller level. Downside of this approach is that we have to import UseInterceptor and our Interceptor, any time we want to use our CurrentUserDecorator. Because interceptors can be applied to one controller at the time, we call them controller scoped. So we are going to wire them up another way.
Second approach is to make our interceptor globally scoped, instead of a controller scoped, so that single instance of our interceptor can be applied to any request that comes to application. To achieve this, we are going to import APP_INTERCEPTOR in UsersModule, and in list of providers replace CurrentInterceptor with an object that contains that interceptor ({ provide: APP_INTERCEPTOR, useClass: CurrentUserInterceptor }). We are going to use second approach. The downside of this approach is that there may be controllers that don't need to have information who current user is, and application will still make that read from the database, but I don't think that it is such a big issue, comparing to the benefits it provides.
Guards will be used to prevent access to the methods that require permission user don't have. Guards return truthy if user can access particular route, falsie (false, null, 0, "", undefined...) otherwise. Guards can be applied on application level, per controller or per individual handler (method in controller). We will create AuthGuard in src/guards folder. That guard will implement CanActivate interface. We are going to reject request if user is not signed in. We are going to apply AuthGuard to the whoami route inside UsersController.
Note: For now, combining GetUser decorator, that will be passed a list of roles with access rights for each method/route or controller and AuthGuard, we can replicate Spring Security mode of protecting routes. GetUser decorator would return user only if user has any role from passed list. Session would store userId, and list of user's roles.

## Testing

Unit testing - testing individual features. Integration/e2e testing - testing workflow. To test features, we need to create fake service class, since it depends on repository service and other services, like UserService. We will create auth.service.spec.ts file and fakeUsersService that will be passed through DI. We can run test using command "npm run test:watch". This will run all spec.ts files. Pressing "p" we can add name of the test file we want to run. This code: "{ provide: UsersService, useValue: fakeUsersService, }" means whenever someone asks for UsersService, give him fakeUsersService, which has simplified methods. This code "create: (email: string, password: string) => Promise.resolve({ id: 1, email, password } as Users),", without "as Users" part was returning error, because we didn't implement logInsert, logUpdate and logDelete methods. This way we explicitly tell to treat this object as Users, regardless of those missing methods.
To significantly increase test speed, we need to change line "test:watch": "jest --watch" by adding "--maxWorkers=1" to "test:watch": "jest --watch --maxWorkers=1".
To test signin method, we need to pass hashed and salted password. While that can be done by providing hashed and salted version od particular password, test will fail if we change hashing method. That is the reason why we added "const users: Users[] = [];" when we invoke sign up method, it will add that users to the list. Then we have to modify find and create methods in fakeUsersService. (Old method will stay commented). Before any signin test, we need to invoke sign up.
To test UsersController, we need to create two fake services, because it depends on UsersService and AuthService. We have to implement, inside fake services, only methods we are going to use for tests. There is not much sense to test controllers, because to test decorators etc, we need to implement e2e tests. Those test are run by command "npm run test:e2e". During e2e testing we completely skip main.ts file and configurations in that file. In this case, validation pipe and cookie session. First solution is to write configuration from bootstrap function in separate file and use it where needed (only app.user() and app-useGlobalPipes()).
Second approach is to move cookie session and validation pipe from main.ts to app.module.ts. That way, e2e test can use them. In app.module providers section, add APP_PIPE object. This way we set global validation pipe. For adding cookie session globally, we will add method configure() inside AppModule class, and apply cookie session to MiddlewareConsumer and chain on that ".forRoutes('\*')" which means that we want to use that middleware on every request in entire application. Since data are stored in database, we have to change username before each testing of signUp method, or test is going to fail if we try to insert existing email. To solve date, when start test (and create new instance of application) we have to wipe existing database, or create new one. We are going to use two separate databases, one for development mode, when we run application from the terminal, and other for automated testing. For that, we are going to use nestjs recommended way of working with environment variables: ConfigService.

## Config

To use config files, we first have to install "npm i @nestjs/config". Nestjs documentation states that it is ok to have multiple .env files. Dotenv documentation states that there should never be more than one .env file. .env files should never be committed to git. We will create twi separate .env files: development.env and test.env in root directory. We will setup ConfigModule and ConfigService inside the AppModule. ConfigModule defines which file we are going to use, while ConfigService exposes values from that file. We will use "forRoot()" method of ConfigModule. Parameter isGlobal means should we use this configuration for whole application, while envFilePath defines which file to use. We have to refactor TypeORM configuration, so that it can access ConfigurationService through dependency injection system. After that we only need to ensure that we set NODE_ENV variable each time we run application in development or test mode. For every OS, except MS Windows, it would be enough to just write, at the start of a command "NODE_ENV=...", but to work on all OSs, we have to install and use cross-env library "npm i cross-env", and to add "cross-env NODE_ENV=...". I am adding those two .env file to git, on purpose this time. Otherwise, this should be avoided. The only thing left to be done is to delete test database after each testing. It is done by adding line ("setupFilesAfterEnv": ["\<rootDir>/setup.ts"]) inside "test/jest-e2e.json" file. Root dir, in this case, is test. In setup.ts file we declare global.beforeEach() function that will be run before every single test, across all \*.spec.ts files. There, we are creating method to delete/clean our test database.

## TypeORM relations

We are going to use decorators to make oneToMany and manyToOne relations. Users entity will have @OneToMany() decorator, while in Reports entity, we are going to create ManyToOne() decorator. This way we create a circular dependency between this two classes. Function () => EntityName, inside decorators, ensures that Entity class is defined in a moment we reference it. Reports create() method returns whole user object, including password. To solve this, we are going to create reports.dto.ts file and create userId from reports object, using @Transform() decorator. Then we are going to decorate method in controller, with Serialize interceptor, that will ensure that outgoing response is of ReportsDto type, which shows only userId value, instead of complete Users object.

## Authorization

We are going to add a boolean property, named "admin", to the users entity. Then we are going to create admin.guard.ts file where we will return true only if currentUser.admin is true. Then we are adding @UseGuards(AdminGuard) decorator to admin routes. This won't be enough. Nestjs handles request in following order: first it applies middleware to the requests, then guards, interceptors can be run before or after request handlers, but always after guards, and then returns response. AdminGuard expects to find currentUser in session object, but that property is set in CurrentUserInterceptor, which is called after guard. The solution is to convert interceptor into middleware. We are going to create CurrentUserMiddleware file into src/users/middleware folder. Than we are replacing CurrentUserInterceptor with CurrentUserModule inside UsersModule. Configure function, that contains our middleware, will be called automatically.
Note: Since request, as defined in Express, doesn't have currentUser or session property, we are going to expand its definition in current-user.middleware.ts file by "declare global", but it doesn't work in my linter.

## Deployment

First thing to do is to read cookie key from environment variable, using configService. Second is to set database synchronize to false. All our database configurations needs to be done in .js file. We will rewrite TypeOrmModule inside AppModule, so we can use ormconfig.js file inside root directory. Then, in package.json add line in script section: "typeorm": "cross-env NODE_ENV=development node --require ts-node/register ./node_modules/typeorm/cli.js". This command allows us to generate migration files. Command "npm run typeorm migration:generate -- -n initial-schema -o" should generate migration file, but it doesn't work, throws an error. Command "npm run typeorm migration:run" should execute migration. This is completely changed in recent updates of TypeOrm, so I will rollback every change stated here. We created file named "Procfile" in root directory, with run command for production environment. This project ended using sqlite database, since TypeOrm config didn't work. Heroku is platform to deploy nestjs projects.
